#ifndef __YCALCUL__
#define __YCALCUL__


#include "Ylib.h"

///////////////////////////////////////////////////
// Fonctions de calcul
///////////////////////////////////////////////////

/// Calcul l'arrondi d'une valeur relle
short YCalcArrondi (double x);

/// Calcul du barycentre d'un objet
point_3d YCalcBarycentre (objet_3d obj);

/// Calcule l'quation du plan passant par les points A, B et C
void YCalcEqPlan (point_3d A, point_3d B, point_3d C, double *a, double *b, double *c, double *d);

/// Calcul l'quation d'une face
int YCalcEqFace (objet_3d obj, short numFace);

/// Calcul l'quation du plan passant par une arte et l'observateur
int YCalcEqPlanArete (objet_3d obj, short numArete);

/// Vrifie si la face donne d'un objet est visible
int YCalcFaceAvant (objet_3d obj, short numFace, int vue);

/// Recherche toutes les faces visibles d'un objet
short* YCalcFacesAvant (objet_3d obj, int vue); 

/// Verifie si une arte est visible, partiellement visible ou cache
point_3d** YCalcAreteCachee (objet_3d obj, point_3d deb, point_3d fin, int vue);


#endif
