#include "YPrint.h"

/** 
 * Affiche le contenu du double buffer  l'cran.
 *
 * Vide le double buffer ? A faire
 *
 * \return Rien
 */
void YPrintBuffer (void) {
  // Affichage  l'cran
  XCopyArea(display,buffer,win,gc,0,0,width,height,0,0);
  // RAZ du buffer
  /*
  XSetForeground(display,gc,background);
  XFillRectangle(display,buffer,gc,0,0,width,height);
  */
}

/**
 * Allume (dans le double buffer) le pixel pass en paramtre.
 *
 * Modifie avant allumage le contexte graphique pour... A faire
 *
 * \param  x : coordonnes (en x) par rapport  la fentre
 * \param  y : coordonnes (en y) par rapport  la fentre
 * \return Rien
 */
void YPrintPixel (int x, int y) {
  XSetForeground(display,gc,background); //peut etre util pour la couleur??
  XDrawPoint(display,buffer,gc,x,y);
}

/**
 * Allume (dans le double buffer) la srie de pixels passe en paramtre.
 *
 * Modifie avant allumage le contexte graphique pour... A faire
 *
 * \param  pixels : les coordonnes par rapport  la fentre d'affichage de tous les
 *                  pixels  allumer.
 * \param  nb_pixels : le nombre de pixels  allumer
 * \return Rien
 */
void YPrintPixels (XPoint *pixels, int nb_pixels) {
  XSetForeground(display,gc,foreground); //peut etre util pour la couleur??
  XDrawPoints(display,buffer,gc,pixels,nb_pixels,CoordModeOrigin);
}

/** Affichage d'un point en 3d dans le double buffer */ //??????? A faire
void YPrintPoint3D (point_3d point, int type) {} //type = projection ou perspective

/**
 * Trace dans le buffer une ligne dont les extrmits sont passes en paramtre.
 * Le trac utilise l'algorithme de Bresenham.
 * \param  deb : la "1re" extrmit de la droite
 * \param  fin : la "2me" extrmit de la droite
 * \return Rien
 */
void YPrintLine2D (point_2d deb, point_2d fin) {
  double pente,erreur;
  XPoint *pixels;
  int nb_pixels;
  short x,y;
  int i;
  int incr;

  erreur = 0;
  pente = (fin.y-deb.y)/(fin.x-deb.x);
  if ((pente >= -1) && (pente <= 1)) {
    /* La pente est douce => il faut faire varier x de 1 en 1 */
    short deb_x,fin_x;
    if (deb.x > fin.x)
      incr = -1;
    else
      incr = 1;
    // Calcule le nombre de points sur la ligne
    deb_x = YCalcArrondi(deb.x);
    fin_x = YCalcArrondi(fin.x);
    nb_pixels = abs(fin_x-deb_x)+1;
    // Allocation du tableau de points
    pixels = malloc(nb_pixels*sizeof(XPoint));
    // Remplissage du tableau
    x = deb_x;
    y = YCalcArrondi(deb.y);
    for (i=0 ; i<nb_pixels ; i++) { //tant que...
      pixels[i].x = x;
      pixels[i].y = y;
      x += incr;
      erreur += pente;
      if (erreur >= 0.5) {
	y += incr;
	erreur --;
      }
      else if (erreur <= -0.5) {
	y -= incr;
	erreur++;
      }
    }
  }
  else {
    /* La pente est raide => il faut faire varier y de 1 en 1 */
    short deb_y,fin_y;
    // Trace la ligne dans le sens des y croissants
    if (deb.y > fin.y)
      incr = -1;
    else
      incr = 1;
    // Calcule le nombre de points sur la ligne
    deb_y = YCalcArrondi(deb.y);
    fin_y = YCalcArrondi(fin.y);
    nb_pixels = abs(fin_y-deb_y)+1;
    // Allocation du tableau de points
    pixels = malloc(nb_pixels*sizeof(XPoint));
    // Remplissage du tableau
    y = deb_y;
    x = YCalcArrondi(deb.x);
    for (i=0 ; i<nb_pixels ; i++) { //tant que...
      pixels[i].x = x;
      pixels[i].y = y;
      y += incr;
      erreur += 1/pente;
      if (erreur >= 0.5) {
	x += incr;
	erreur --;
      }
      else if (erreur <= -0.5) {
	x -= incr;
	erreur++;
      }
    }
  }
  YPrintPixels(pixels,nb_pixels);
}

/** Affichage d'une ligne en 3d dans le double buffer */ // ???????? A faire
void YPrintLine3D (point_3d deb, point_3d fin, int type) {}
