#include <stdlib.h>
#include "Ylib.h"


GC       gc;         // Contexte graphique
Display *display;    // Connection serveur
Window   root;       // Fentre racine
Window   win;        // Fentre graphique (Texte 3D)
int      screen;     // Numro d'affichage de l'cran
Pixmap   buffer;      // Double buffer pour supprimer le scintillement
unsigned long pixel_blanc; // Valeur du blanc
unsigned long pixel_noir;  // Valeur du noir
unsigned long foreground;  // Couleur de l'avant-plan
unsigned long background;  // Couleur de l'arrire-plan
unsigned int  width;       // Largeur de la fentre graphique
unsigned int  height;      // Hauteur de la fentre graphique

objet_3d *objets; // Liste des objets de la scne


int main (int argc, char* argv[]) {
  int pos_x,pos_y;
  XEvent ev;
  XSetWindowAttributes attrib;

  point_2d deb,fin;

  // Ouverture de la connexion au serveur
  display = XOpenDisplay(NULL);
  // Initialisations diverses
  gc=DefaultGC(display,screen);
  screen = DefaultScreen(display);
  root = RootWindow(display,screen);
  pixel_noir = BlackPixel(display,screen);
  pixel_blanc = WhitePixel(display,screen);
  foreground = pixel_noir;
  background = pixel_blanc;
  // Cration d'une fentre
  pos_x = pos_y = 10;
  width = 500;
  height = 400;
  win = XCreateSimpleWindow(display,root,pos_x,pos_y,width,height,3,foreground,background);
  /*
  attrib.background_pixel= background;
  attrib.border_pixel = pixel_noir;
  attrib.event_mask=ExposureMask|KeyPressMask|ButtonPressMask|ButtonReleaseMask|PointerMotionMask;
  win = XCreateWindow(display,root,pos_x,pos_y,width,height,3,DefaultDepth(display,screen),InputOutput,DefaultVisual(display,screen),CWEventMask|CWBackPixel|CWBorderPixel,&attrib);
  */
  // Slection d'vnements
  XSelectInput(display,win,ButtonPressMask|ButtonReleaseMask|KeyPressMask);
  // Affichage de la fentre
  XMapWindow(display,win);
  // Cration d'un double buffer
  buffer = XCreatePixmap(display,root,width,height,DefaultDepth(display,screen));
  XSetForeground(display,gc,background);
  XFillRectangle(display,buffer,gc,0,0,width,height);

  // Boucle de gestion des vnements
  while (1) {
    XNextEvent(display,&ev);
    switch (ev.type) {
    case ButtonPress:
      deb.x = (double)ev.xbutton.x;
      deb.y = (double)ev.xbutton.y;
      break;
    case ButtonRelease:
      fin.x = (double)ev.xbutton.x;
      fin.y = (double)ev.xbutton.y;
      YPrintLine2D(deb,fin);
      YPrintBuffer();
      break;
    case KeyPress:
      printf("bye...\n");
      exit(EXIT_SUCCESS);
      break;
    }
  }

  exit(EXIT_FAILURE); // A priori on sortira directement ds la boucle d'vnements
}
